/* ============================================================================================== *
 *                                                                                                *
 *                                       Xi Blockchain                                            *
 *                                                                                                *
 * ---------------------------------------------------------------------------------------------- *
 * This file is part of the Galaxia Project - Xi Blockchain                                       *
 * ---------------------------------------------------------------------------------------------- *
 *                                                                                                *
 * Copyright 2018-2019 Galaxia Project Developers                                                 *
 *                                                                                                *
 * This program is free software: you can redistribute it and/or modify it under the terms of the *
 * GNU General Public License as published by the Free Software Foundation, either version 3 of   *
 * the License, or (at your option) any later version.                                            *
 *                                                                                                *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;      *
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      *
 * See the GNU General Public License for more details.                                           *
 *                                                                                                *
 * You should have received a copy of the GNU General Public License along with this program.     *
 * If not, see <https://www.gnu.org/licenses/>.                                                   *
 *                                                                                                *
 * ============================================================================================== */

#include <gmock/gmock.h>

#include <Xi/Rct/Constants.h>
#include <Xi/Rct/Algorithm/KeyArithmetic.h>

#define XI_TESTSUITE T_Xi_Rct_KeyArithmetic

TEST(XI_TESTSUITE, MultiplyBasePoint) {
  using namespace ::testing;
  using namespace ::Xi;
  using namespace ::Xi::Rct;

  std::vector<std::pair<KeyVector, Rct::Key>> Oracle{
      {{{{{0xc7, 0xc9, 0x5a, 0x1b, 0xb3, 0x20, 0x10, 0xe3, 0xe9, 0x78, 0x5d, 0xf2, 0x96, 0x1c, 0x19, 0xc9,
           0x95, 0xb1, 0x7e, 0x73, 0x45, 0xe1, 0x9,  0x2b, 0xc3, 0xea, 0x1b, 0x1b, 0xbb, 0xdd, 0x39, 0xc}}},
        {{0x30, 0x9b, 0x32, 0xf3, 0x91, 0x98, 0x9b, 0x7, 0x2d, 0x91, 0x84, 0x19, 0xd8, 0x20, 0x64, 0xf,
          0x3d, 0x2,  0x24, 0xce, 0x6a, 0x95, 0xce, 0xa, 0x37, 0x3d, 0xd3, 0x7a, 0xf6, 0xa1, 0xe5, 0x50}}},
       {{{{0xcf, 0x53, 0xfd, 0xf8, 0x63, 0x30, 0x93, 0xe7, 0x52, 0x53, 0x46, 0xc4, 0xb7, 0x8e, 0x18, 0xdc,
           0xd7, 0x28, 0x1,  0xb4, 0xee, 0x8,  0xc0, 0x15, 0xdd, 0x74, 0x2f, 0x86, 0x7,  0x72, 0xa0, 0x9}}},
        {{0xda, 0xe6, 0x9a, 0xba, 0x70, 0xe1, 0x1d, 0x6c, 0x9,  0x34, 0x4b, 0xca, 0x63, 0x84, 0xf,  0x16,
          0xdd, 0x56, 0xdd, 0x33, 0xbc, 0x1f, 0xe8, 0x24, 0x12, 0x5a, 0x2c, 0x50, 0xb1, 0x49, 0xcf, 0x47}}},
       {{{{0x2f, 0xec, 0x1c, 0x11, 0x93, 0xa9, 0xbb, 0x28, 0xd3, 0x9a, 0x6d, 0xc0, 0xd6, 0x2f, 0x1a, 0xcb,
           0xa5, 0x6e, 0xb3, 0x75, 0xac, 0x0,  0x88, 0xca, 0xd3, 0xe6, 0xdc, 0x14, 0xd5, 0xa,  0xa7, 0x1}}},
        {{0x25, 0xe5, 0xf7, 0xc3, 0x4b, 0xad, 0xc2, 0xf1, 0x73, 0x3c, 0x96, 0x39, 0x2b, 0x4a, 0x65, 0x2a,
          0xe2, 0x2c, 0x78, 0x73, 0x67, 0x77, 0xfe, 0x44, 0xe8, 0xd6, 0x6c, 0xd3, 0x4d, 0x19, 0x88, 0xdf}}},
       {{{{0xfe, 0x55, 0xf1, 0x22, 0xcd, 0xa7, 0xb8, 0x28, 0xd2, 0x9b, 0x7e, 0x62, 0x88, 0x78, 0x10, 0x34,
           0xce, 0xe9, 0x35, 0xdc, 0xaa, 0xe6, 0xe9, 0xdc, 0x47, 0xf6, 0x82, 0x13, 0x88, 0x2b, 0x1e, 0x1}}},
        {{0x13, 0xd9, 0xb7, 0x72, 0x26, 0xb2, 0xc7, 0x43, 0x4c, 0x28, 0xae, 0x3,  0x4a, 0x68, 0x93, 0xbf,
          0x73, 0x5a, 0xa3, 0xe7, 0x97, 0x86, 0x43, 0x29, 0x8c, 0x25, 0x8d, 0x84, 0xef, 0xd6, 0x76, 0x41}}},
       {{{{0x76, 0x73, 0xb7, 0x45, 0x11, 0xfd, 0x5c, 0x11, 0x35, 0xfd, 0xa9, 0xb4, 0x93, 0xc5, 0xc0, 0x1b,
           0x97, 0xc9, 0xa9, 0x59, 0x5a, 0x92, 0x24, 0x76, 0x69, 0x4d, 0x82, 0x33, 0x3c, 0x8e, 0xaa, 0x5}}},
        {{0xfe, 0x34, 0x54, 0x3c, 0xbb, 0xc,  0xf6, 0x9a, 0xc4, 0x9b, 0x4e, 0xf4, 0x7,  0xc8, 0xc9, 0x87,
          0xe2, 0x72, 0x75, 0x86, 0x6b, 0x7f, 0xcd, 0xbd, 0x97, 0x95, 0x64, 0x52, 0x45, 0x37, 0x13, 0xcf}}},
       {{{{0xb9, 0xc7, 0xad, 0xe9, 0x84, 0x66, 0x4, 0x20, 0xa0, 0x68, 0x39, 0x5e, 0xb,  0x56, 0x22, 0x51,
           0xc6, 0x28, 0xc5, 0x6a, 0xf1, 0x55, 0x6, 0x24, 0x5b, 0xef, 0x59, 0x0,  0xb4, 0xc0, 0x52, 0x6}}},
        {{0xc9, 0x2c, 0xa6, 0x54, 0x40, 0xec, 0x53, 0xe3, 0x5, 0x39, 0x88, 0x2f, 0x62, 0x58, 0xb7, 0xb7,
          0x7b, 0xa1, 0x95, 0x33, 0xad, 0xf,  0xd,  0x59, 0x2, 0x2e, 0x39, 0xd6, 0xca, 0x3,  0x4c, 0x48}}},
       {{{{0x9c, 0xdf, 0x35, 0x1, 0x84, 0x79, 0x66, 0x2f, 0x14, 0x8,  0x8f, 0x1d, 0x51, 0x65, 0x87, 0x25,
           0xa0, 0x39, 0x35, 0x8, 0x97, 0x60, 0x36, 0x5a, 0xcf, 0x23, 0x23, 0x33, 0x85, 0xac, 0xcd, 0x8}}},
        {{0x8a, 0xfe, 0x2f, 0x8,  0x8b, 0x15, 0xf9, 0x4e, 0xea, 0xdf, 0x8,  0xbc, 0x45, 0xbb, 0xdc, 0x8a,
          0x4d, 0xd1, 0x8d, 0x75, 0x2a, 0x84, 0x29, 0x3f, 0x89, 0x32, 0x9e, 0xcc, 0x2d, 0x69, 0x5f, 0x99}}},
       {{{{0x91, 0x7c, 0xfd, 0xa8, 0xdc, 0xb9, 0x7c, 0x90, 0x7b, 0xd3, 0x46, 0xd3, 0x77, 0xa0, 0x9d, 0xec,
           0x38, 0xe2, 0xec, 0x89, 0x4d, 0x8f, 0x76, 0xbe, 0xd9, 0xc,  0xc4, 0x40, 0x8e, 0xd5, 0x4f, 0x7}}},
        {{0x9a, 0xf9, 0xf2, 0x84, 0x53, 0x7d, 0x52, 0x9e, 0x94, 0xf1, 0x2a, 0xb, 0xc0, 0xbc, 0xc7, 0x5b,
          0xea, 0x94, 0xd5, 0xd4, 0xd6, 0x53, 0x36, 0xbc, 0xc7, 0x8a, 0xd3, 0xf, 0x41, 0x6b, 0x7d, 0x8e}}},
       {{{{0xa,  0x8e, 0xcd, 0xfa, 0x34, 0x4b, 0x15, 0xbe, 0x83, 0x92, 0xb7, 0x34, 0xdd, 0xb4, 0x9e, 0x88,
           0x68, 0xdd, 0xfd, 0xe2, 0x6d, 0x91, 0x85, 0xab, 0xca, 0x24, 0xf7, 0xdc, 0xd,  0x43, 0xa9, 0x7}}},
        {{0xbf, 0xe2, 0x3,  0x6d, 0xf4, 0x97, 0xeb, 0x43, 0xb9, 0xd5, 0x9e, 0xb1, 0xc4, 0xe5, 0xc7, 0x30,
          0xe,  0x60, 0xe0, 0x3,  0xd4, 0xd2, 0x73, 0x9a, 0x7a, 0x2a, 0x8a, 0xf2, 0xb0, 0x51, 0x44, 0x71}}},
       {{{{0xf3, 0xb2, 0x86, 0x2c, 0xc5, 0x49, 0xd1, 0x4,  0xf6, 0x83, 0x12, 0x12, 0x29, 0x54, 0xa1, 0xfd,
           0x42, 0x84, 0x31, 0xa3, 0x2c, 0x19, 0x99, 0x79, 0x29, 0xda, 0xa4, 0x16, 0x5f, 0x1,  0x85, 0x7}}},
        {{0x1d, 0xd0, 0x71, 0xd3, 0xb4, 0x6a, 0xd3, 0xf5, 0x65, 0x61, 0x1f, 0xf5, 0xcc, 0x61, 0x66, 0xc,
          0x35, 0x45, 0xed, 0x1e, 0xfa, 0xab, 0xe9, 0xc8, 0x96, 0xeb, 0xfb, 0x7d, 0x7,  0xe,  0x23, 0x66}}},
       {{{{0x39, 0xbd, 0xfa, 0x76, 0x4a, 0x3b, 0xfa, 0x62, 0x33, 0x47, 0xc2, 0xb5, 0x1,  0xb5, 0x8c, 0x39,
           0xef, 0xcf, 0x7,  0x64, 0x89, 0xd9, 0x76, 0x81, 0x62, 0xd0, 0xfd, 0xdc, 0xb1, 0xf9, 0xeb, 0xf}}},
        {{0xbe, 0x13, 0xac, 0xc6, 0xf0, 0xbd, 0x50, 0xb9, 0xe,  0x1b, 0x50, 0xa3, 0x52, 0xea, 0x1f, 0xc9,
          0xb9, 0xaf, 0x5d, 0x96, 0xc2, 0x4c, 0xb6, 0xcb, 0xba, 0xff, 0xc,  0x17, 0xb5, 0x5c, 0xa6, 0x1f}}},
       {{{{0x2d, 0x4a, 0xeb, 0x7d, 0x14, 0x6,  0xb2, 0x2b, 0xa8, 0xec, 0x7a, 0xc1, 0x5d, 0xf0, 0x15, 0x8c,
           0x6,  0x33, 0xe7, 0xdf, 0xc9, 0xfd, 0xd7, 0xeb, 0x14, 0x90, 0xfc, 0x3e, 0x3f, 0xf8, 0x4e, 0x8}}},
        {{0xd3, 0x92, 0x21, 0x8, 0x39, 0x36, 0x4e, 0x9a, 0x7f, 0x74, 0x20, 0x47, 0xf4, 0xb2, 0xa3, 0xa3,
          0x37, 0x15, 0x33, 0x9, 0x0,  0xf7, 0x57, 0xe3, 0xba, 0x6a, 0x61, 0x3e, 0x4c, 0x8c, 0xe0, 0xad}}},
       {{{{0xc3, 0x7,  0xcc, 0x4e, 0x2d, 0xf9, 0x37, 0xa6, 0xb0, 0xa2, 0x2a, 0x57, 0x8d, 0x56, 0xbe, 0xad,
           0x15, 0xbc, 0x93, 0x0,  0x76, 0x6a, 0x5a, 0x50, 0x15, 0x22, 0xfd, 0xfc, 0x78, 0x70, 0x60, 0xf}}},
        {{0xeb, 0x4f, 0x66, 0xcb, 0xef, 0xb4, 0x14, 0xdd, 0xd1, 0x4,  0xd4, 0x48, 0x37, 0x4,  0x8b, 0xe9,
          0xc6, 0xff, 0xf8, 0x23, 0x56, 0x4b, 0x5c, 0xbc, 0xd2, 0x7d, 0xdd, 0xb8, 0x92, 0xff, 0x29, 0x78}}},
       {{{{0x2e, 0xa5, 0xa6, 0xfd, 0xe9, 0xd3, 0xf1, 0x3e, 0xcc, 0xdb, 0x76, 0x9b, 0xd7, 0x95, 0xff, 0xb7,
           0xf8, 0x4,  0x50, 0x49, 0xe2, 0xb7, 0x6e, 0x20, 0xbc, 0xd9, 0x44, 0x16, 0xce, 0xd3, 0x71, 0x7}}},
        {{0x1e, 0x3e, 0x36, 0x7a, 0xd3, 0x93, 0x67, 0xd2, 0xf8, 0xda, 0x7d, 0xc8, 0x94, 0xa4, 0xdd, 0xd7,
          0x6f, 0xa0, 0x9f, 0xea, 0xff, 0x40, 0x79, 0xf1, 0xcb, 0xfc, 0xf0, 0x7d, 0xa2, 0xa0, 0xed, 0xa3}}},
       {{{{0xd3, 0x84, 0x1b, 0x9b, 0x26, 0x20, 0x58, 0x31, 0xc0, 0x2d, 0xca, 0x5f, 0x9,  0xb9, 0x3a, 0xbe,
           0x6a, 0x17, 0x3d, 0xa1, 0xd,  0x5d, 0x9e, 0x7a, 0x76, 0x3d, 0x2c, 0xa1, 0x62, 0xf7, 0x9a, 0x1}}},
        {{0x93, 0x45, 0x3f, 0x4d, 0x2b, 0xd, 0x50, 0x6b, 0xd7, 0xf9, 0x36, 0xcb, 0x8,  0x4f, 0xc5, 0x3c,
          0x14, 0xcd, 0xd5, 0xf7, 0x27, 0x5, 0x4,  0xca, 0x7d, 0x2b, 0xa1, 0xb7, 0x7d, 0xe9, 0xe0, 0x96}}},
       {{{{0x6f, 0x56, 0xe4, 0x38, 0xcd, 0x20, 0xdf, 0xed, 0xb2, 0x4a, 0x7a, 0xda, 0x19, 0x53, 0x87, 0xc4,
           0x39, 0xea, 0x82, 0xc1, 0x55, 0xf8, 0xce, 0x33, 0xbf, 0x36, 0xca, 0xc0, 0xe8, 0x2,  0x64, 0x8}}},
        {{0x24, 0x7f, 0xa5, 0x4b, 0x6b, 0x18, 0xf9, 0xd4, 0xc1, 0x82, 0xdd, 0xfa, 0x9,  0x98, 0xa1, 0x16,
          0xa7, 0xa6, 0xb4, 0x98, 0x91, 0x3a, 0xc6, 0xd2, 0xca, 0xf7, 0x2d, 0x1b, 0x42, 0xa2, 0x25, 0xb8}}},
       {{{{0x25, 0x18, 0xf7, 0xf2, 0x52, 0xc5, 0x5e, 0x80, 0x7e, 0x54, 0xc3, 0xd7, 0xfc, 0xf3, 0xe,  0x76,
           0xa,  0x9b, 0x8,  0x7e, 0x33, 0x1b, 0x7a, 0x65, 0xea, 0xc5, 0x6e, 0xf8, 0x60, 0x13, 0x13, 0xc}}},
        {{0x24, 0x25, 0x3d, 0x75, 0x41, 0x35, 0x91, 0x1a, 0x47, 0x9, 0x5f, 0x58, 0x5a, 0x11, 0x10, 0xac,
          0xbb, 0xae, 0xe7, 0xb3, 0x37, 0x9b, 0x51, 0xaa, 0xb2, 0x2, 0xd8, 0x26, 0x6,  0x4d, 0xb3, 0x86}}},
       {{{{0xe5, 0xab, 0xbe, 0xb9, 0x1,  0xf3, 0xc3, 0x84, 0xa9, 0x75, 0x47, 0x1b, 0xbf, 0x47, 0x26, 0x58,
           0x6c, 0xba, 0x36, 0x7e, 0x59, 0x45, 0x60, 0x3d, 0x54, 0xc1, 0xdb, 0x8b, 0xcb, 0x72, 0x15, 0xe}}},
        {{0x10, 0x91, 0x2e, 0x61, 0x53, 0x45, 0x1a, 0x53, 0xf7, 0xb7, 0xc3, 0x54, 0x88, 0x36, 0x48, 0x38,
          0xe5, 0x45, 0xa5, 0xd4, 0xcc, 0xea, 0x14, 0x4d, 0x7c, 0xee, 0x9b, 0xbf, 0x3c, 0x55, 0xbc, 0xe6}}},
       {{{{0x74, 0x59, 0x91, 0x1d, 0x4,  0x4f, 0x7a, 0x6e, 0x24, 0xe7, 0x1a, 0x6f, 0xe9, 0xfb, 0x43, 0xf0,
           0xe4, 0x72, 0x27, 0x3c, 0xda, 0xdc, 0x8a, 0xed, 0x18, 0x3f, 0x44, 0x1d, 0xa0, 0x8d, 0x3a, 0xe}}},
        {{0x2f, 0xc9, 0xff, 0x59, 0xfd, 0xf7, 0x95, 0x66, 0xe4, 0x93, 0x1a, 0x15, 0xd2, 0x6a, 0x3a, 0xf,
          0x6f, 0x85, 0x47, 0x8d, 0x2c, 0x82, 0xb3, 0xbc, 0x77, 0xe8, 0xa1, 0xc7, 0x77, 0xc9, 0x87, 0x1d}}},
       {{{{0xed, 0x78, 0x62, 0x9b, 0xb6, 0x1f, 0xf6, 0xda, 0xe1, 0xe0, 0x78, 0x5d, 0x12, 0x9e, 0xc5, 0x82,
           0x2e, 0x19, 0xfb, 0x6d, 0xc,  0x8f, 0x52, 0xfd, 0x33, 0x5d, 0x99, 0x85, 0x6d, 0x2c, 0xe3, 0x2}}},
        {{0x1a, 0xba, 0x99, 0xf5, 0x49, 0xeb, 0xf1, 0x4f, 0x5b, 0xc6, 0x20, 0x5c, 0xf1, 0xeb, 0xd3, 0x7a,
          0x3b, 0x9c, 0x7f, 0x63, 0x68, 0xf,  0xc0, 0xa0, 0xd2, 0x8e, 0x6b, 0x2c, 0x51, 0xad, 0x41, 0x72}}},
       {{{{0x25, 0xa9, 0x13, 0x7c, 0xe1, 0x9f, 0x31, 0xea, 0xa8, 0xcb, 0x74, 0x54, 0xde, 0x90, 0x6,  0x77,
           0x4a, 0x41, 0x19, 0x9d, 0x8,  0xd6, 0xf3, 0xb1, 0x56, 0x82, 0x79, 0x5d, 0x68, 0xb0, 0x4e, 0xa}}},
        {{0x79, 0xdc, 0x5b, 0x49, 0xac, 0x4c, 0xd3, 0x20, 0x63, 0x5e, 0xf7, 0x16, 0x4e, 0x3b, 0x24, 0xf5,
          0x5c, 0x1c, 0x3,  0x8e, 0x68, 0xc6, 0x82, 0x85, 0xc5, 0x45, 0xbf, 0x22, 0xaa, 0xc7, 0x19, 0x14}}},
       {{{{0xe1, 0x34, 0x98, 0x97, 0x49, 0xb4, 0x9c, 0xde, 0x30, 0xa5, 0x9d, 0x13, 0x2d, 0x14, 0xe9, 0x32,
           0xc9, 0x13, 0xf6, 0xec, 0x5a, 0x32, 0x6b, 0xe6, 0x9f, 0x8e, 0x4b, 0xa6, 0x25, 0xc1, 0xf6, 0x8}}},
        {{0x70, 0x91, 0xf9, 0xb1, 0xc6, 0x2f, 0xfd, 0x9c, 0x9d, 0x12, 0xf0, 0x9d, 0xb0, 0x72, 0x6a, 0xb2,
          0xa1, 0x3f, 0xcb, 0x45, 0xa2, 0xb5, 0x9f, 0x4,  0x1c, 0x63, 0x48, 0x7e, 0x8a, 0x3e, 0x4d, 0xd0}}},
       {{{{0xa0, 0x8e, 0x5e, 0x7c, 0x26, 0xf7, 0x54, 0x7c, 0x26, 0xda, 0x33, 0xd1, 0x4b, 0xec, 0x25, 0x92,
           0xef, 0x1b, 0xff, 0xcc, 0x25, 0xb5, 0x57, 0x77, 0x9e, 0x79, 0x34, 0xbf, 0xec, 0xf,  0x49, 0x6}}},
        {{0xfc, 0xca, 0xf0, 0x91, 0xa5, 0x1f, 0x3a, 0x51, 0x82, 0xd1, 0xe9, 0xbc, 0xc3, 0xd,  0xce, 0x6b,
          0x4e, 0x4d, 0x6b, 0x51, 0xa4, 0xf9, 0xdf, 0x75, 0x44, 0x41, 0xa1, 0x72, 0x8a, 0x56, 0xc9, 0x1c}}},
       {{{{0xfd, 0x88, 0xc4, 0xe3, 0x24, 0x51, 0xe8, 0xec, 0x5a, 0x6f, 0x38, 0x6,  0x75, 0xf8, 0x70, 0x96,
           0xa6, 0x6c, 0xdc, 0x11, 0xb2, 0x35, 0x9d, 0xa6, 0x41, 0xa3, 0x4f, 0x90, 0xcb, 0xdc, 0x21, 0x1}}},
        {{0x3b, 0x21, 0x45, 0xe9, 0x4a, 0x27, 0x56, 0x23, 0x6c, 0xb3, 0xa8, 0xad, 0x3,  0xa4, 0xb0, 0x8,
          0x1a, 0x7a, 0xfa, 0x68, 0xe9, 0xed, 0xdd, 0x8a, 0xff, 0x66, 0x46, 0xe7, 0x8f, 0xd5, 0x14, 0x5a}}},
       {{{{0x97, 0x50, 0x68, 0x5d, 0xf3, 0x7d, 0xb1, 0x5c, 0xf4, 0x88, 0xaf, 0xdb, 0xc5, 0xb5, 0x66, 0x16,
           0x62, 0xce, 0x86, 0x3c, 0xbf, 0xfd, 0x5d, 0xdf, 0x33, 0xe9, 0x7c, 0x95, 0x3b, 0xd0, 0x45, 0x9}}},
        {{0xa5, 0xb5, 0x3c, 0x88, 0x8e, 0x12, 0x80, 0x1d, 0xd0, 0xc6, 0x22, 0x1,  0xb1, 0xc,  0xe5, 0xf4,
          0xc9, 0x37, 0xa4, 0xbd, 0x30, 0x74, 0xa,  0x90, 0x82, 0x49, 0x82, 0x93, 0x36, 0xb5, 0x84, 0x28}}},
       {{{{0xf7, 0x64, 0x84, 0xde, 0x9c, 0x9f, 0x72, 0xca, 0x8f, 0xd2, 0xc6, 0x6f, 0x87, 0x83, 0x35, 0xa6,
           0x23, 0xc5, 0x6f, 0x2b, 0x85, 0xf2, 0xc0, 0xeb, 0xc6, 0x8f, 0x41, 0xfe, 0xbe, 0x77, 0x8,  0x9}}},
        {{0x33, 0x41, 0xff, 0xac, 0xa2, 0xf8, 0xc4, 0x73, 0xde, 0x2d, 0x69, 0x4c, 0xf9, 0x8,  0x77, 0x7f,
          0xe5, 0x43, 0xdf, 0xdd, 0xee, 0x22, 0x44, 0x31, 0xd6, 0x1b, 0xee, 0x4e, 0x6,  0xa9, 0x26, 0x86}}},
       {{{{0x5e, 0xd6, 0x4c, 0x62, 0x92, 0x38, 0x81, 0x62, 0xa4, 0x41, 0xc5, 0x88, 0xea, 0x3f, 0xcd, 0x6d,
           0xc,  0x1d, 0x7e, 0xf1, 0xe9, 0x12, 0x10, 0xac, 0x5f, 0x44, 0x80, 0xcc, 0xb8, 0xd4, 0xcf, 0x8}}},
        {{0x9b, 0x81, 0xb3, 0x62, 0x3,  0x5c, 0x60, 0x18, 0xef, 0xa6, 0xb7, 0xba, 0x48, 0xc0, 0xe,  0x6a,
          0x36, 0x8a, 0xb5, 0xbc, 0x30, 0x6f, 0x10, 0x78, 0xd2, 0xe0, 0x71, 0x71, 0xf,  0xb0, 0x44, 0x67}}},
       {{{{0x18, 0x8a, 0x45, 0x27, 0x41, 0x9e, 0x3c, 0x4a, 0x51, 0x78, 0x44, 0x70, 0x8e, 0x39, 0x10, 0x83,
           0xc6, 0xb4, 0x52, 0x6d, 0x10, 0x7,  0x7d, 0xd1, 0xf2, 0xdd, 0xe1, 0xee, 0xd1, 0xd3, 0xa,  0x2}}},
        {{0x52, 0x8e, 0x3b, 0x89, 0x1e, 0x3,  0x6b, 0xfc, 0x45, 0x87, 0xda, 0xa6, 0x24, 0x20, 0xed, 0x96,
          0xb1, 0x82, 0x43, 0xa6, 0x7f, 0xb9, 0xbc, 0xf7, 0x8c, 0xf0, 0x6e, 0xf9, 0x1a, 0xf2, 0x29, 0x61}}},
       {{{{0xea, 0xc7, 0x4a, 0x86, 0x34, 0xbf, 0xfd, 0xa6, 0xa8, 0xb, 0xcf, 0x36, 0x23, 0x9,  0x80, 0xcb,
           0xf5, 0xf9, 0xe2, 0xc2, 0x42, 0xc,  0x46, 0x2b, 0xbf, 0xd, 0x2e, 0xd,  0x4c, 0x10, 0x52, 0x1}}},
        {{0x43, 0x35, 0x60, 0x67, 0xc5, 0xf9, 0x2f, 0x3d, 0x5d, 0x85, 0xfd, 0x55, 0x9e, 0x37, 0xf0, 0xfc,
          0x2a, 0x31, 0x69, 0xa9, 0x7a, 0xb,  0x91, 0x1b, 0x14, 0xd4, 0x8b, 0x72, 0xb2, 0x97, 0x20, 0xdd}}},
       {{{{0x5e, 0x6c, 0xec, 0xfc, 0xac, 0x8c, 0xee, 0x89, 0xb6, 0x3,  0x10, 0x2,  0xfd, 0x1d, 0x1f, 0x3f,
           0x11, 0x67, 0xf0, 0x12, 0x63, 0x62, 0xb7, 0xf9, 0x96, 0xb6, 0x75, 0x7e, 0xf7, 0x6c, 0x81, 0x9}}},
        {{0x27, 0xb7, 0xa9, 0xc9, 0xf5, 0xc0, 0x4,  0xfc, 0x31, 0x50, 0x9b, 0x65, 0x7c, 0x29, 0x37, 0x91,
          0x8d, 0x67, 0xcc, 0xf7, 0x1e, 0x19, 0xa4, 0x7,  0x82, 0xa7, 0x7e, 0xa3, 0x3e, 0x87, 0x66, 0x6e}}},
       {{{{0x1f, 0xc4, 0xf3, 0x17, 0x15, 0x61, 0xb,  0xe,  0x78, 0x20, 0x76, 0xdf, 0xbf, 0x2e, 0x8e, 0x8b,
           0x3e, 0xe4, 0x3d, 0xe6, 0x34, 0xfa, 0xbf, 0x5b, 0x10, 0x2f, 0x81, 0x3e, 0xce, 0x2f, 0x26, 0x4}}},
        {{0xbe, 0x57, 0x24, 0xc,  0xf4, 0xa9, 0x3f, 0x2e, 0x15, 0xa0, 0x52, 0x4c, 0x90, 0xc0, 0x21, 0xe5,
          0x77, 0xa9, 0x67, 0x44, 0xa1, 0xea, 0xed, 0x95, 0x95, 0xba, 0x1f, 0x2a, 0xbf, 0xd,  0x5d, 0xe9}}},
       {{{{0x9d, 0xa7, 0xd9, 0x31, 0x6d, 0x7d, 0x83, 0x3b, 0x8e, 0x31, 0xc1, 0x86, 0xcf, 0xd1, 0x13, 0x50,
           0x4b, 0xae, 0xef, 0x38, 0x2e, 0x9d, 0x6d, 0x37, 0xa7, 0xcf, 0x21, 0xcd, 0xed, 0x79, 0xa8, 0x5}}},
        {{0x70, 0x97, 0xcf, 0x69, 0xe9, 0x39, 0x34, 0x24, 0x8f, 0x49, 0x5f, 0x51, 0xee, 0x7a, 0x2f, 0xe7,
          0xca, 0x2c, 0x6e, 0x2,  0x49, 0xaf, 0x13, 0x53, 0x66, 0xa9, 0xc6, 0xe6, 0xdd, 0x6a, 0x66, 0x3e}}},
       {{{{0xea, 0xb9, 0xcd, 0xa1, 0x4b, 0xd0, 0xe,  0xd,  0x21, 0x1d, 0x17, 0x69, 0xef, 0x41, 0xc9, 0xad,
           0x6f, 0x88, 0xe5, 0x86, 0x49, 0x3a, 0xcb, 0x8b, 0xc,  0x1a, 0x16, 0x1a, 0xb8, 0x55, 0x77, 0xa}}},
        {{0xac, 0xa7, 0xa,  0x85, 0xe1, 0x3d, 0xca, 0x52, 0xd1, 0x5b, 0x38, 0xcf, 0xa8, 0x1,  0xd2, 0x95,
          0xb6, 0x6c, 0xb9, 0x9f, 0xa3, 0xa9, 0x21, 0xfb, 0xe9, 0xdc, 0x9f, 0xed, 0x19, 0x34, 0xf,  0x77}}},
       {{{{0x4b, 0xea, 0x51, 0x1e, 0x8b, 0x4f, 0x50, 0x76, 0xd,  0x8c, 0x28, 0xa1, 0x1a, 0xef, 0xba, 0xc5,
           0x6b, 0x53, 0x4a, 0xd3, 0xf4, 0x1a, 0x41, 0xc4, 0xf8, 0xdb, 0xa8, 0xa9, 0xaa, 0x22, 0x0,  0x7}}},
        {{0x64, 0xc5, 0x62, 0xe9, 0xdf, 0x89, 0xe1, 0x40, 0xf7, 0xc5, 0x90, 0x73, 0xa, 0xe9, 0x72, 0x91,
          0x67, 0x48, 0x52, 0x1,  0x5,  0x21, 0x8,  0x9f, 0x40, 0x72, 0x64, 0x9b, 0xd, 0xc4, 0x9c, 0xcc}}},
       {{{{0xfc, 0xba, 0x5b, 0xfe, 0x4a, 0x41, 0x8a, 0xa1, 0x54, 0x86, 0x58, 0x5d, 0x71, 0x77, 0xd9, 0xa8,
           0x8d, 0x88, 0x96, 0xb0, 0x38, 0x98, 0x51, 0x34, 0x98, 0xeb, 0x24, 0xcc, 0xf1, 0xd2, 0x7,  0xf}}},
        {{0xa, 0x1b, 0x93, 0x7d, 0xf,  0x78, 0xf0, 0xa0, 0x4e, 0x30, 0x7b, 0x67, 0x7e, 0xf0, 0x49, 0xf6,
          0x1, 0x36, 0x9,  0x1c, 0x99, 0x61, 0xac, 0x78, 0x61, 0xf9, 0xf1, 0x7,  0xdd, 0xa7, 0x91, 0xe7}}},
       {{{{0xe0, 0x73, 0x6e, 0xc2, 0x91, 0xb1, 0x3f, 0x4e, 0x35, 0x8d, 0xfa, 0x88, 0x9d, 0x84, 0x2a, 0x33,
           0x24, 0x37, 0x6f, 0x73, 0x1b, 0xa3, 0x99, 0x27, 0x75, 0x8f, 0x6c, 0x4c, 0xd4, 0x92, 0x3,  0x3}}},
        {{0x96, 0x1f, 0x52, 0x3c, 0x5f, 0x6,  0x41, 0x93, 0x78, 0x23, 0xcb, 0x29, 0x74, 0xe0, 0x93, 0x22,
          0xf7, 0xe,  0x6d, 0xec, 0x78, 0x1e, 0x92, 0x2b, 0x8e, 0xad, 0xca, 0xb5, 0x4e, 0xd,  0x3d, 0x39}}},
       {{{{0x4b, 0x5e, 0x1d, 0x1,  0x17, 0x78, 0xf6, 0xf5, 0xbc, 0x63, 0xf5, 0x9d, 0xf,  0x45, 0xad, 0xca,
           0x3a, 0xec, 0xc7, 0xca, 0xa5, 0xe4, 0xb7, 0xef, 0x34, 0xd3, 0xe4, 0xfc, 0xac, 0x13, 0x2b, 0x7}}},
        {{0x1d, 0xb7, 0x5b, 0x9c, 0x15, 0x5f, 0xfe, 0x16, 0xa6, 0x6d, 0x9e, 0xe7, 0x46, 0xef, 0xd0, 0xd6,
          0x85, 0x89, 0xe7, 0xff, 0x45, 0xe8, 0x53, 0x9a, 0x77, 0xa5, 0xa4, 0x8c, 0x61, 0x3,  0xb6, 0x58}}}}};

  for (const auto& oracle : Oracle) {
    auto r0 = key_multiply_scalar_with_basepoint(oracle.first.front());
    Rct::Key r1;
    key_multiply_scalar_with_basepoint_inplace(oracle.first.front(), r1);
    EXPECT_EQ(r0, oracle.second);
    EXPECT_EQ(r1, oracle.second);
  }
}
